#include "lcd.h"
#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>

int INITIAL_SIZE = 7;
typedef struct
{
	int x;
	int y;
} coord;

int head;
int tail;
int score;
coord point;
int lenght;
int defeat;
coord snake[MAX_SIZE];

void generate_coord(coord *input) 
{
    input->x = 15;
    input->y = 28;
}

void getRandPosition(int *x, int *y) 
{ 
	*x = (1 + rand() % (47 )); 
	*y = (1 + rand() % (50 )); 
}

void init_snake()
{
	int i;
	lcd_init();
	lcd_contrast(0x40);	

	matrix_init();

	lenght = INITIAL_SIZE;
	head   = INITIAL_SIZE - 1;
	tail   = 0;
	score  = 0;
	defeat = 0;
	directie = 0;
	getRandPosition(&point.x, &point.y);
	for (i = 0; i < lenght ; ++ i )
	{
		snake[i].x = Y_SIZE / 2;
		snake[i].y = i + INITIAL_SIZE;
	}

}

void set_snake(void)
{
	int i;
	for ( i = 0 ; i < head ; ++ i )
	{
		if ( i < tail )
		{
			reset_pixel(snake[i].x, snake[i].y);
		}else
		{
			set_pixel(snake[i].x, snake[i].y);
		}
	}

	set_pixel(point.x,point.y);

}

void advance(void)
{

	head = (head + 1) % MAX_SIZE;
	tail = (tail + 1) % MAX_SIZE;
	if (directie == 0)
	{
		//miscare dreapta
		if ( head - 1 >= 0 )
		{
			snake[head].y = snake[head - 1].y + 1;
			snake[head].x = snake[head - 1].x;
		}else 
		{
			snake[head].y = snake[MAX_SIZE -1].y + 1;
			snake[head].x = snake[MAX_SIZE -1].x;
		}

	} else if (directie == 1)
	{
		//miscare stanga
		if ( head - 1 >= 0 )
		{
			snake[head].y = snake[head - 1].y - 1;
			snake[head].x = snake[head - 1].x;
		}else 
		{
			snake[head].y = snake[MAX_SIZE -1].y - 1;
			snake[head].x = snake[MAX_SIZE -1].x;			
		}

	} else if (directie == 2)
	{
		//miscare sus
		if ( head - 1 >= 0 )
		{
			snake[head].x = snake[head - 1].x - 1;
			snake[head].y = snake[head - 1].y;
		}else 
		{
			snake[head].x = snake[MAX_SIZE -1].x - 1;
			snake[head].y = snake[MAX_SIZE -1].y;			
		}		


	} else if (directie == 3)
	{
		//miscare jos
		if ( head - 1 >= 0 )
		{
			snake[head].x = snake[head - 1].x + 1;
			snake[head].y = snake[head - 1].y;
		}else 
		{
			snake[head].x = snake[MAX_SIZE -1].x + 1;
			snake[head].y = snake[MAX_SIZE -1].y;			
		}		
	}

	//verificare iesire din cadru
	if (snake[head].x <= 0 || snake[head].y <= 0 ||
		snake[head].x >= 48 ||snake[head].y >=80 )
	{
		defeat = 1;
	}

	//verificare gasire pixel
	if ( snake[head].x == point.x && snake[head].y == point.y)
	{
		tail --;
		reset_pixel(point.x,point.y);
		getRandPosition(&point.x, &point.y);
		score ++;
	}
}

void init_buttons(void) 
{
    DDRD &= ~((1 << PD1)|(1 << PD0)|(1 << PD6)|(1 << PD4));
    PORTD |= ((1 << PD1)|(1 << PD0)|(1 << PD6)|(1 << PD4));
   

}


void test_lcd(void)
{
	// Setup LCD
	lcd_init();
	lcd_contrast(0x40);
	
	// Print on first line
	lcd_goto_xy(1,1);
	lcd_str("Quantum Torque");
	
	
	while(1);
}

int main(void) {
	srand(0);
	init_snake();
	init_buttons();
	set_snake();
	draw_matrix();
	directie = -1;
	while(1)
	{
		if ( directie < 0 )
		{
			get_heading();
			continue;
		}
		get_heading();
		advance();
		set_snake();
		draw_matrix();
		if (defeat == 1)
		{
			lcd_goto_xy(10,20);
			lcd_chr(score + '0');
			break;
		}
		_delay_ms(250);
	}

	while(1);

}
